//+------------------------------------------------------------------+
//|                                               CrossMACD_beta.mq4 |
//|                                      Copyright  2006, komposter |
//|                                      mailto:komposterius@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, komposter"
#property link      "mailto:komposterius@mail.ru"

extern int  _MagicNumber = 1122;

#include <OneOrderControl.mq4>

int start()
{
	int _GetLastError = 0;
	
	//----     (  )
	OneOrderInit( _MagicNumber );

	//----      
	double MACD_1 = iMACD( Symbol(), 0, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, 1 );
	double MACD_2 = iMACD( Symbol(), 0, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, 2 );

	//----  ,   ,  ,    :
	if ( _Ticket > 0 )
	{
		//----   -,
		if ( _Type == OP_BUY )
		{
			//----    0-  ,
			if ( NormalizeDouble( MACD_1, Digits + 1 ) <  0.0 && 
				  NormalizeDouble( MACD_2, Digits + 1 ) >= 0.0    )
			{
				//----  
				if ( !OrderClose( _Ticket, _Lots, Bid, 5, Green ) )
				{
					_GetLastError = GetLastError();
					Alert( " OrderClose  ", _GetLastError );
					return(-1);
				}
			}
			//----    ,  -     
			else
			{ return(0); }
		}
		//----   -,
		if ( _Type == OP_SELL )
		{
			//----    0-  ,
			if ( NormalizeDouble( MACD_1, Digits + 1 ) >  0.0 && 
				  NormalizeDouble( MACD_2, Digits + 1 ) <= 0.0    )
			{
				//----  
				if ( !OrderClose( _Ticket, _Lots, Ask, 5, Red ) )
				{
					_GetLastError = GetLastError();
					Alert( " OrderClose  ", _GetLastError );
					return(-1);
				}
			}
			//----    ,  -     
			else
			{ return(0); }
		}
	}
	//----   ,   ( _Ticket == 0 )
	//----    0-  ,
	if ( NormalizeDouble( MACD_1, Digits + 1 ) >  0.0 && 
	  	NormalizeDouble( MACD_2, Digits + 1 ) <= 0.0    )
	{
		//----   
		if ( OrderSend( Symbol(), OP_BUY, 0.1, Ask, 5, 0.0, 0.0, "CrossMACD", 
		  	_MagicNumber, 0, Green ) < 0 )
		{
			_GetLastError = GetLastError();
			Alert( " OrderSend  ", _GetLastError );
			return(-1);
		}
		return(0);
	}
	//----    0-  ,
	if ( NormalizeDouble( MACD_1, Digits + 1 ) <  0.0 && 
	  	NormalizeDouble( MACD_2, Digits + 1 ) >= 0.0    )
	{
		//----   
		if ( OrderSend( Symbol(), OP_SELL, 0.1, Bid, 5, 0.0, 0.0, "CrossMACD", 
		  	_MagicNumber, 0, Red ) < 0 )
		{
			_GetLastError = GetLastError();
			Alert( " OrderSend  ", _GetLastError );
			return(-1);
		}
		return(0);
	}
return(0);
}

